import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from TiledImage import *
from tests import * 
#import pdb

class TestMadeInstall(ZopeTestCase.ZopeTestCase):

    def afterSetUp(self):
      pass

    def testExistence(self):
      assert (app.objectValues('ImaNote')), "Made installation failed"
      #pdb.set_trace()

    def testMaps(self):
      assert made.getMaps()[0].getId()=='testImage', 'Maps not found' 

    def testAnnotations(self): 
      made.addMap('testImage2', im_mag,open('test.jpg'), 'a testmap');
      made.addMap('testImage3', 4, open('test.jpg'), 'a testmap');
      id1=made.generateId()
      id2=made.generateId()
      made.testImage2.show_annotations=('testImage2', 'testImage3')
      made.testImage3.addAnnotation(Annotation(0,0,10,10,id1))
      made.testImage2.getAnnotation(id1)
      try:
        made.testImage2.editAnnotation(id1, url='foo')
      except:
        pass
      else: self.fail("Shouldn't be able to edit annotation")
      assert not made.testImage3.getAnnotation(id1).getUrl()=='foo',\
          'Annotation not updated correctly'
      assert not made.testImage2.getAnnotation(id1).getUrl()=='foo',\
          'Annotation not updated correctly'
      made.testImage3.editAnnotation(id1, url='foo2')
      assert made.testImage2.getAnnotation(id1).getUrl()=='foo2',\
          'Annotation not updated correctly'
      assert made.testImage3.getAnnotation(id1).getUrl()=='foo2',\
          'Annotation not updated correctly'
      made.testImage2.edit_annotations=('testImage3',)
      made.testImage2.editAnnotation(id1, url='foo3')
      assert made.testImage2.getAnnotation(id1).getUrl()=='foo3',\
          'Annotation not updated correctly'
      assert made.testImage3.getAnnotation(id1).getUrl()=='foo3',\
          'Annotation not updated correctly'
      made.testImage2.edit_annotations=('testImage3',)
      made.testImage2.show_annotations=()
      made.testImage2.addAnnotation(Annotation(0,0,10,10,id2))
      made.testImage2.editAnnotation(id2, url='foo4')
      try:
        made.testImage2.getAnnotation(id2)
      except:
        pass
      else: self.fail("Shouldn't be able to view annotation")
      made.testImage3.edit_annotations=('testImage2','testImage3')
      id3=made.generateId()
      made.testImage3.addAnnotation(Annotation(0,0,50,50,id3))
      made.testImage2.show_annotations=('testImage2',)
      made.testImage2.getAnnotation(id3)


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestMadeInstall))
    return suite

if __name__ == '__main__':
    framework()

