import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from TiledImage import *
from tests import * 

class TestUiMap(ZopeTestCase.FunctionalTestCase):

    def afterSetUp(self):
      pass

    def testMapMainPage(self):
      _url='testMade/testImage'
      body=self.publish(_url).getBody()
      assert re.search('testMade/testImage\?level=2&amp;center_x=%s&amp;center_y=%s&amp;width=640&amp;height=480&amp;format=png&amp;' % (im_width/2, im_height/2), body), 'Magnification link not shown '+body
      assert re.search('src="get_overview_image\?', body),\
          'Overview image not shown'
      assert re.search('src="get_image\?', body), 'Map image not shown'
      assert re.search('width=800', body), 'Image size link not shown'
          
    def testMapNavigation(self):
      _url='testMade/testImage/?level=1&center_x=500&center_y=500&width=640&'+\
          'height=480&format=png&click_point=330,220'
      body=self.publish(_url).getBody()
      assert body.find('center_x=%s' % (500+10*im_mag))!=-1,\
          'Map not navigated correctly'
      assert body.find('center_y=%s' % (500-20*im_mag))!=-1,\
          'Map not navigated correctly'

    def testOverviewMapNavigation(self):
      _url='testMade/testImage/get_overview_image_url?overview_max_width=200&'+\
          'overview_max_height=300&level=0&center_x=500&center_y=500&'+\
          'width=640&height=480&format=png' #Set overview_width and height
      self.publish(_url)
      ov_width_2=self.app.testMade.testImage.getOverviewWidth()/2
      ov_height_2=self.app.testMade.testImage.getOverviewHeight()/2
      _url='testMade/testImage/?level=0&center_x=500&center_y=500&'+\
          'width=640&height=480&format=png&ov_point=%s,%s' % (ov_width_2,\
          ov_height_2)
      #Click middle of ov_map so new center_x should be mapwidth/2
      body=self.publish(_url).getBody()
      assert re.search('center_x=%s' % (im_width/2), body), \
          'Overview map not navigated correctly'
      assert re.search('center_y=%s' % (im_height/2), body), \
          'Overview map not navigated correctly'
      

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestUiMap))
    return suite

if __name__ == '__main__':
    framework()
